'FFSubmenu=Skalieren
'FFName=ScalePrint-Profiler
'
' ********************************************************************
' Profiler (Skript fr FixFoto)
' Funktion:	Erstellung von Profilen und Aufruf von FF-Skripten mit ausgewhltem Profil
' Voraussetzung: Einstelldaten des Skripts sind in der Registry abgelegt
'
' Copyright Harald Maeckler, Dsseldorf 2014
' ********************************************************************
'
' Anpassung fr "Bilderinfo nach Excel"
'
' ********************************************************************
' Version 1.02 vom 13.04.2014	- Transfer per Clipboard entfllt wieder
'									bei FF-Version < 3.60.02 muss ein Bild geladen sein
'									ab  FF-Version < 3.60.02 ist keine Manahme mehr erforderlich
'								- Test auf unzulssige Zeichen im Stichwort beim Erstellen eines Profils
' Version 1.01 vom 07.04.2014	- Anpassung an mehrzeilige Registrydaten
'								- Transfer per Clipboard whlbar
' Version 1.00 vom 31.03.2014	- Betaversion
' ********************************************************************
'
'** Start Kurzbeschreibung *******************************************
' Profiler / ab Version 1.00
' ===============
' 
' Einfhrung
' =======
' Mit dem Skript Profiler knnen die Einstellungen eines im Profilerskript angegebenen
' Zielskripts in den Profilen A, B, C und D gespeichert und mit einem Stichwort ver-
' sehen werden. Anschlieend kann das Zielskript durch Wahl eines Profils mit den ge-
' speicherten Einstellungen gestartet werden.
' Voraussetzung ist, dass die Einstellungen des Zielskripts beim Beenden des Skripts
' in der Registry gesichert und beim nchsten Start mit diesen Registrydaten die letzten
' Einstellungen wieder hergestellt werden.
' 
' A, B, C, D	Starten des definierten Zielskripts mit dem entsprechenden Profil
'		durch Mausklick oder Bettigung der Taste A, B, C oder D,
'		vorausgesetzt es wurden die Profile vorher erstellt (siehe Bearbeiten)
' ?		Aufruf der vorliegenden Kurzbeschreibung
' Abbrechen	Profiler vorzeitig beenden
' Bearbeiten	Aufruf des Dialogs zum Erstellen, Lschen und Umbenennen der Profile
' 
' Bearbeiten
' =======
' Beim ersten Aufruf  der Profilbearbeitung durch Anklicken von 'Bearbeiten' wird der
' Bearbeitungsdialog mit vier undefinierten Profilen A, B, C und D gezeigt.
' 
' Erstellen
' -----------
' Man muss erst einmal ein Profil erstellen. Dazu markiert man ein Profil links vom
' Symbol A, B, C oder D und gibt oberhalb des Symbols ein Stichwort ein. Das geht am
' einfachsten mit Doppelklick auf undefiniert und dann Eingabe eines kurzen Begriffs
' wie beispielsweise Standard.
' 
' Wird jetzt 'Erstellen' bettigt, werden die zuletzt beim Beenden des Zielskripts
' bestehenden Einstellungen als Profil mit eingegebenem Stichwort abgespeichert. Der
' Erfolg des Abspeicherns wird durch ein farbiges Symbol angezeigt.
' 
' Auf die gleiche Weise knnen bis zu drei weitere Profile abgespeichert werden. Es
' knnen auch bereits gespeicherte Profile mit neuen Einstellungen berschrieben
' werden. Aber immer daran denken, es werden die Einstellungen als Profil abgespei-
' chert, die zuletzt beim Beenden des Zielskripts bestanden.
' 
' Umbenennen
' ----------------
' Das Stichwort fr ein abgespeichertes Profil kann umbenannt werden. Dazu muss das
' Profil markiert, das Stichwort gendert und dann 'Umbenennen' bettigt werden.
' 
' Lschen
' ----------
' Ein abgespeichertes Profil kann gelscht werden. Dazu muss das zu lschende Profil
' markiert und dann 'Lschen' bettigt werden.

' Beenden
' ----------
' Mit Anklicken von 'Beenden' wird die Profilbearbeitung beendet und wieder der Haupt-
' dialog angezeigt. Hier sind die vorgenommenen Bearbeitung direkt sichtbar und knnen
' getestet werden.
' 
' Weitere Befehle
' ==========
' Skript lschen
' -----------------
' Wird die Entfernung des Skripts gewnscht, kann mit der Tastenkombination Alt + X
' eine Lschroutine aufgerufen werden. Es wird geprft, ob ein dazu gehrendes zip-
' Archiv im Skriptordner abgelegt ist. Wenn ja, wird vor dem Lschen angeboten, davon
' eine Sicherheitskopie an einem beliebigen Speicherort abzulegen. Dann werden nach-
' einander die Skriptdatei und alle Zusatzdateien incl. der erstellten Profile ge-
' lscht. Abschlieend wird die FixFotoScript.ini bereinigt.
' 
' Nach manueller Durchfhrung einer Automatischen Skriptkonfiguration ist das Skript
' mit allen Komponenten aus der FixFoto-Umgebung entfernt.
' 
' 
' Benutzung des Skripts auf eigene Gefahr!
' 
' Copyright Harald Maeckler, Dsseldorf
' 
'** Ende Kurzbeschreibung ***********************************************

'**Start Encode**
Option Explicit

' ***** anzupassende Definitionen ***************************************
'FFSubmenu und FFName manuell anpassen
Const OriginalSkript	= "ScalePrint_Profiler.vbs"			'Name des vorliegenden Skripts
Const Zielskript 		= "ScalePrint.vbs"					'Name des aufzurufenden Skripts
Const RegSchluessel 	= "FF_ScalePrint"					'Registryschlssel
Const Ablageordner		= "MeckiScript\ScalePrint_Profile"	'Ablageordner der Profile
Const Dialog			= "Profiler fr ScalePrint"			'Dialogname
Const Beschreibung		= "Profiler.pdf"					'Beschreibung im Ablageordner
' ***********************************************************************
const RegPfad 			= "HKEY_CURRENT_USER\Software\Joachim Koopmann Software\FixFoto\Script\"		'Registerpfad - unverndert lassen
const Version 			= "V 1.02"							'Original-Skriptversion						'bei Bedarf anpassen
' ***********************************************************************

Dim FF_Skriptpfad,Skriptname,ProfilOrdner,flagProfil,StartSkript,RegDaten,ProfilDatei,n
Dim ProfilEintrag(2,3)	'(0,x) = Stichwort / x = Profilnummer 0 - 3
						'(1,x) = Imagepfad fr das Symbol
						'(2,x) = Profilname
Dim Ausfuehrung : Ausfuehrung = false
Dim SkriptKill,Antwort,TempFile	 : SkriptKill = false	'Lschroutine
Dim objFS,WshShell										'Objekte
Dim Kurzbeschreibung, KBvorhanden, LaengeMax			'Kurzbeschreibung
const ForReading = 1, ForWriting = 2
Dim Abbruch : Abbruch = false

'------------------------------------------------------------------------
Set objFS = CreateObject("Scripting.FileSystemObject")
Set WshShell = CreateObject("WScript.Shell")

call Main

Set objFS = Nothing
Set WshShell = Nothing
'------------------------------------------------------------------------
Sub Main

on error resume next							'Kontrolle ob Skript in FF-Umgebung gestartet wurde
	FF_Skriptpfad = FF_GetFFPathEx(2)
 	if err > 0 then
		msgbox "Das Skript funktioniert nur in der Programmumgebung von FixFoto!",vbCritical,"Abbruch"
		exit sub
	end if
on error goto 0

'Startskript
if objFS.FileExists(FF_Skriptpfad & "\" & Zielskript) then
	StartSkript = FF_Skriptpfad & "\" & Zielskript
else
	msgbox "Das Skript '" & Zielskript & "' konnte nicht gefunden werden!",vbCritical,"Abbruch"
	exit sub
end if

'Originalskript
if objFS.FileExists(FF_Skriptpfad & "\" & OriginalSkript) then
	Skriptname = OriginalSkript
else
	msgbox "Das Skript '" & OriginalSkript & "' konnte nicht gefunden werden!" & vbNewLine & _
		   "Wahrscheinlich wurde der Name verndert!",vbCritical,"Abbruch"
	exit sub
end if

'bei FF < 3.60.02 muss ein Bild geladen sein
if not Version_OK("3.60.02") and FF_GetImageWidth = 0 then
	msgbox "Es muss irgendein Bild geladen sein!",vbExclamation,"Abbruch"
	exit sub
end if

'Profilordner
ProfilOrdner = FF_Skriptpfad & "\" & Ablageordner
if not objFS.FolderExists(ProfilOrdner) then
	objFS.CreateFolder(ProfilOrdner)
	call Symbolerzeugung
end if

'** Start Dialog Profile **
FF_AddDialog Dialog,195,82
FF_AddControl Dialog,"Starten mit Profil  ....","GROUP",5,5,185,49
FF_AddControl Dialog,"|","STATIC",10,15,40,10
FF_SetControlStyle Dialog,"|",1
FF_AddControl Dialog,"img_A","IMAGE",20,28,20,20
FF_AddControl Dialog,"Profil&a","BUTTON",20,44,1,1
FF_AddControl Dialog,"||","STATIC",55,15,40,10
FF_SetControlStyle Dialog,"||",1
FF_AddControl Dialog,"img_B","IMAGE",65,28,20,20
FF_AddControl Dialog,"Profil&b","BUTTON",65,44,1,1
FF_AddControl Dialog,"|||","STATIC",100,15,40,10
FF_SetControlStyle Dialog,"|||",1
FF_AddControl Dialog,"img_C","IMAGE",110,28,20,20
FF_AddControl Dialog,"Profil&c","BUTTON",110,44,1,1
FF_AddControl Dialog,"||||","STATIC",145,15,40,10
FF_SetControlStyle Dialog,"||||",1
FF_AddControl Dialog,"img_D","IMAGE",155,28,20,20
FF_AddControl Dialog,"Profil&d","BUTTON",155,44,1,1
FF_AddControl Dialog,"?","BUTTON",11,64,11,11
FF_AddControl Dialog,"Abbrechen","BUTTON",104,64,33,11
FF_AddControl Dialog,"Bearbeiten","BUTTON",148,64,33,11
FF_AddControl Dialog,"&x","BUTTON",0,0,1,1
'** End Dialog Profile **

FF_AddControl Dialog,Version,"STATIC",32,64,24,11
FF_SetControlStyle Dialog,Version,1

'Tooltips
if Version_OK("3.30.06") then
	FF_SetControlTooltip Dialog,"?", "" &_
						 "Anzeige der Kurzbeschreibung"
	FF_SetControlTooltip Dialog,"Abbrechen", "" &_
						 "Skript Profiler beenden"
	FF_SetControlTooltip Dialog,"Bearbeiten", "" &_
						 "Profile erstellen, umbenennen, lschen"
end if

if Version_OK("3.40.52") then FF_SetTooltipDelay 2500
FF_ActivateControl Dialog,"&x"
FF_SetDialogTimer Dialog, 100

do
	Select Case FF_ShowDialog (Dialog)
	Case "&x"
		if len(Skriptname) = 0 then
			msgbox "Das Skript '" & OriginalSkript & "'konnte nicht gefunden werden!" & vbNewLine & _
				   "Mglicherweise wurde der Name gendert.",vbExclamation,"Keine Lschung mglich"
		else
			Antwort = msgbox("Soll das Skript '" & Skriptname & "'" & vbNewline & _
							 "wirklich gelscht werden?", _
							 vbYesNo + vbQuestion,"Sicherheitsabfrage")
			if Antwort = vbYes then
				SkriptKill = true
				exit do
			end if
		end if
	Case "TIMER"
		call ProfilListe
		FF_SetDialogTimer Dialog, 0
	Case "img_A","Profil&a"
		ProfilDatei = ProfilOrdner & "\" & ProfilEintrag(2,0)
		call RegEintrag
		Ausfuehrung = true : exit do
	Case "img_B","Profil&b"
		ProfilDatei = ProfilOrdner & "\" & ProfilEintrag(2,1)
		call RegEintrag
		Ausfuehrung = true : exit do
	Case "img_C","Profil&c"
		ProfilDatei = ProfilOrdner & "\" & ProfilEintrag(2,2)
		call RegEintrag
		Ausfuehrung = true : exit do
	Case "img_D","Profil&d"
		ProfilDatei = ProfilOrdner & "\" & ProfilEintrag(2,3)
		call RegEintrag
		Ausfuehrung = true : exit do
	Case "?"
		if objFS.FileExists(ProfilOrdner & "\" & Beschreibung) then
			on error resume next
			WshShell.Run chr(34) & ProfilOrdner & "\" & Beschreibung & chr(34),1,false
			if err <> 0 then
				msgbox "Die Kurzbeschreibung konnte nicht als PDF-Datei geffnet werden." & vbNewLine & _
				   	"Die Datei ist gelscht oder es ist kein PDF-Reader installiert (?)." & vbNewLine & vbNewLine &_
				   	"Ersatzweise erfolgt eine Textanzeige!",vbExclamation,"Hinweis"
				err.clear
			
				if not KBvorhanden then	call KurzbeschreibungLesen
				if KBvorhanden then
					call KurzbeschreibungAnzeigen
				else
					msgbox "Keine Kurzbeschreibung gefunden!",vbExclamation,"Meldung"
				end if
			
			end if
			on error GoTo 0
		else
			if not KBvorhanden then	call KurzbeschreibungLesen
			if KBvorhanden then
				call KurzbeschreibungAnzeigen
			else
				msgbox "Keine Kurzbeschreibung gefunden!",vbExclamation,"Meldung"
			end if
		end if
	Case "Bearbeiten"
		call ProfilBearbeitung
	Case "CANCEL","Abbrechen"
		exit do
	Case Else
	End Select
loop

FF_CloseDialog (Dialog)

if Ausfuehrung then 
	FF_CallScript StartSkript
	FF_Reload
end if

if SkriptKill then	'ggf. Skript und Zubehr komplett entfernen
	call KillSkript
end if

End Sub
'------------------------------------------------------------------------
Sub Symbolerzeugung
Dim grau,Farben,Farbarray,n

Farben = "8421376/195/12255232/34951"
FarbArray = split(Farben,"/")
grau = 8421504

for n = 0 to ubound(FarbArray)
	FF_NewImage 38,38,FarbArray(n)
	FF_ExtendCanvas 1,1,1,1,255,255,255
	FF_DrawText chr(65 + n),7,1,40,0,600,false,false,"Arial",16777215
	FF_SaveImage ProfilOrdner & "\img_" & chr(65 + n) & ".png",0
next

for n = 0 to 3
	FF_NewImage 38,38,grau
	FF_ExtendCanvas 1,1,1,1,255,255,255
	FF_DrawText chr(65 + n),7,1,40,0,600,false,false,"Arial",16777215
	FF_SaveImage ProfilOrdner & "\img_neutral_" & chr(65 + n) & ".png",0	
next

End Sub
'------------------------------------------------------------------------
Sub RegEintrag
'Eintrag der Registry-Daten
Dim Datei,Zeile,RegArray

Set Datei = objFS.OpenTextFile(ProfilDatei,ForReading, False)

Do While Datei.AtEndOfStream <> True
	Zeile = Datei.ReadLine
	if instr(Zeile,"=") > 0 then		'Beschrnkung erstmalig fr das Skript Bildunterschrift
		RegArray = split(Zeile," = ")
		FF_WriteProfile RegSchluessel,RegArray(0),RegArray(1)
	else
		RegArray(1) = RegArray(1) & vbNewLine & Zeile
	end if
	FF_WriteProfile RegSchluessel,RegArray(0),RegArray(1)
Loop
Datei.Close

End Sub
'------------------------------------------------------------------------
Sub ProfilBearbeitung

'** Start Dialog Profilbearbeitung **
FF_AddDialog "Profilbearbeitung",195,82
FF_AddControl "Profilbearbeitung","Bearbeitung","GROUP",141,57,45,22
FF_AddControl "Profilbearbeitung","Profile","GROUP",5,5,185,49
FF_AddControl "Profilbearbeitung","txtA","SLEDIT",10,15,40,10
FF_SetControlStyle "Profilbearbeitung","txtA",1
FF_AddControl "Profilbearbeitung","flagA","BOOL",10,35,8,8
FF_SetControlStyle "Profilbearbeitung","flagA",16384
FF_AddControl "Profilbearbeitung","img_A","IMAGE",20,28,20,20
FF_AddControl "Profilbearbeitung","txtB","SLEDIT",55,15,40,10
FF_SetControlStyle "Profilbearbeitung","txtB",1
FF_AddControl "Profilbearbeitung","flagB","BOOL",55,35,8,8
FF_SetControlStyle "Profilbearbeitung","flagB",16384
FF_AddControl "Profilbearbeitung","img_B","IMAGE",65,28,20,20
FF_AddControl "Profilbearbeitung","txtC","SLEDIT",100,15,40,10
FF_SetControlStyle "Profilbearbeitung","txtC",1
FF_AddControl "Profilbearbeitung","flagC","BOOL",100,35,8,8
FF_SetControlStyle "Profilbearbeitung","flagC",16384
FF_AddControl "Profilbearbeitung","img_C","IMAGE",110,28,20,20
FF_AddControl "Profilbearbeitung","txtD","SLEDIT",145,15,40,10
FF_SetControlStyle "Profilbearbeitung","txtD",1
FF_AddControl "Profilbearbeitung","flagD","BOOL",145,35,8,8
FF_SetControlStyle "Profilbearbeitung","flagD",16384
FF_AddControl "Profilbearbeitung","img_D","IMAGE",155,28,20,20
FF_AddControl "Profilbearbeitung","Beenden","BUTTON",147,65,33,11
FF_AddControl "Profilbearbeitung","ausgewhltes Profil","GROUP",11,57,127,22
FF_AddControl "Profilbearbeitung","Lschen","BUTTON",99,65,33,11
FF_AddControl "Profilbearbeitung","Umbenennen","BUTTON",58,65,35,11
FF_AddControl "Profilbearbeitung","Erstellen","BUTTON",17,65,33,11
'** End Dialog Profilbearbeitung **

'Eintragungen
for n = 0 to 3
	FF_SetControl "Profilbearbeitung","txt" & chr(65 + n),ProfilEintrag(0,n)
	FF_EnableControl "Profilbearbeitung","txt" & chr(65 + n),false
	FF_SetControl "Profilbearbeitung","img_" & chr(65 + n),ProfilEintrag(1,n)
next

'Vorbesetzung des Profils A
flagProfil = 0
call FlagBestimmung

'Tooltips
if Version_OK("3.30.06") then
	FF_SetControlTooltip "Profilbearbeitung","Beenden", "" &_
						 "Profilbearbeitung beenden"
	FF_SetControlTooltip "Profilbearbeitung","Lschen", "" &_
						 "markiertes Profil lschen"
	FF_SetControlTooltip "Profilbearbeitung","Umbenennen", "" &_
						 "markiertes Profil umbenennen"
	FF_SetControlTooltip "Profilbearbeitung","Erstellen", "" &_
						 "markiertes Profil mit Stichwort erstellen"
end if

do
	Select Case FF_ShowDialog ("Profilbearbeitung")
	Case "flagA"
		flagProfil = 0
		call FlagBestimmung
	Case "flagB"
		flagProfil = 1
		call FlagBestimmung
	Case "flagC"
		flagProfil = 2
		call FlagBestimmung
	Case "flagD"
		flagProfil = 3
		call FlagBestimmung
	Case "Lschen"
		if len(flagProfil) = 0 then
			msgbox "Es ist kein Profil markiert!",vbInformation,"Hinweis"
		else
			call ProfilLoeschen
		end if
	Case "Umbenennen"
		if len(flagProfil) = 0 then
			msgbox "Es ist kein Profil markiert!",vbInformation,"Hinweis"
		else
			call ProfilUmbenennen
		end if
	Case "Erstellen"
		if len(flagProfil) = 0 then
			msgbox "Es ist kein Profil markiert!",vbInformation,"Hinweis"
		else
			call ProfilErstellen
		end if
	Case "CANCEL","Beenden"
		exit do
	Case Else
	End Select
loop

FF_CloseDialog ("Profilbearbeitung")

End Sub
'------------------------------------------------------------------------
Sub FlagBestimmung

'neutralisieren
for n = 0 to 3
		FF_SetControl "Profilbearbeitung","flag" & chr(65 + n),0
		FF_SetControl "Profilbearbeitung","txt" & chr(65 + n),ProfilEintrag(0,n)
		FF_EnableControl "Profilbearbeitung","txt"  & chr(65 + n),false
next

'aktivieren
FF_SetControl "Profilbearbeitung","flag" & chr(65 + flagProfil),1
FF_EnableControl "Profilbearbeitung","txt"  & chr(65 + flagProfil),true

End Sub
'------------------------------------------------------------------------
Sub ProfilListe
Dim ordner,dateien,element,dListe,ext,dListArray,Profil,Bezeichner

Set ordner = objFS.GetFolder(ProfilOrdner)
Set dateien = ordner.Files

'vorhandene Profile ermitteln
For each element in dateien
	ext = objFS.GetExtensionName(ProfilOrdner & "\" & element)
	if ext = "wfp" then
		if len (dListe) = 0 then 
			dListe = element.name
		else
			dListe = dListe & vbNewLine & element.name
		end if
	end if
Next

'neutrale Eintrge
for n = 0 to 3
	ProfilEintrag(0,n) = "undefiniert" : ProfilEintrag(1,n) = ProfilOrdner & "\img_neutral_" & chr(65 + n) & ".png"
	Bezeichner = Bezeichner & "|"
	FF_SetControl Dialog ,Bezeichner,ProfilEintrag(0,n)
	FF_SetControl Dialog,"img_" & chr(65 +  n),ProfilEintrag(1,n)
	FF_EnableControl Dialog,"img_" & chr(65 +  n),false
	FF_EnableControl Dialog,"Profil&" & chr(97 + n),false
next

'vorhandene Profile aktivieren
if len(dListe) > 0 then
	dListArray = split(dListe,vbNewLine)
	for each element in dListArray
		Profil = left(element,1)
		flagProfil = asc(Profil) - 65

		Bezeichner = ""
		for n = 0 to flagProfil : Bezeichner = Bezeichner & "|" : next
		
		ProfilEintrag(0,flagProfil) = mid(element,3,len(element) -6)
		ProfilEintrag(1,flagProfil) = ProfilOrdner & "\img_" & Profil & ".png"
		ProfilEintrag(2,flagProfil) = element
		FF_SetControl Dialog,Bezeichner,ProfilEintrag(0,flagProfil)
		FF_SetControl Dialog,"img_" & Profil,ProfilEintrag(1,flagProfil)
		FF_EnableControl Dialog,"img_" & Profil,true
		FF_EnableControl Dialog,"Profil&" & chr(97 + flagProfil),true
	next
end if

End Sub
'------------------------------------------------------------------------
Sub ProfilLoeschen
Dim ProfDatei,Bezeichner

'Msgbox ProfilEintrag(0,flagProfil) & vbNewLine & ProfilEintrag(1,flagProfil) & vbNewLine & ProfilEintrag(2,flagProfil)
ProfDatei = ProfilOrdner & "\" & ProfilEintrag(2,flagProfil)

if not objFS.FileExists(ProfDatei) then
	msgbox "Es existiert kein Profil!",vbInformation,"Hinweis"
	FF_SetControl "Profilbearbeitung","txt" & chr(65 + flagProfil),"undefiniert"
else
	Antwort = msgbox("Soll das Profil " & ProfilEintrag(2,flagProfil) & vbNewLine &_
					 "wirklich gelscht werden?",vbQuestion + vbYesNo,"Sicherheitsabfrage")
	if Antwort = vbYes then
		objFS.DeleteFile ProfDatei,true
		
		'Eintrge
		ProfilEintrag(0,flagProfil) = "undefiniert"														'neues Stichwort
		ProfilEintrag(1,flagProfil) = ProfilOrdner & "\img_neutral_" & chr(65 + flagProfil) & ".png"	'neues Symbol
		ProfilEintrag(2,flagProfil) = ""																'Profilname
		for n = 0 to flagProfil : Bezeichner = Bezeichner & "|" : next
		FF_SetControl Dialog,Bezeichner,"undefiniert"
		FF_SetControl Dialog,"img_" & chr(65 + flagProfil),ProfilEintrag(1,flagProfil)
		FF_EnableControl Dialog,"img_" & chr(65 + flagProfil),false
		FF_EnableControl Dialog,"Profil&" & chr(97 +  flagProfil),false
		FF_SetControl "Profilbearbeitung","txt" & chr(65 + flagProfil),"undefiniert"
		FF_SetControl "Profilbearbeitung","img_" & chr(65 + flagProfil),ProfilEintrag(1,flagProfil)
	end if
end if

End Sub
'------------------------------------------------------------------------
Sub ProfilUmbenennen
Dim NameNeu,msg1,msg2,msg3,msg4,msg5,Stichwort,Bezeichner

'Msgbox ProfilEintrag(0,flagProfil) & vbNewLine & ProfilEintrag(1,flagProfil) & vbNewLine & ProfilEintrag(2,flagProfil)

Stichwort = ProfilEintrag(0,flagProfil)
Bezeichner = "txt" & chr(65 + flagProfil)

msg1 = "Da das ausgewhlte Profil nicht existiert," & vbNewLine & "kann das Stichwort nicht umbenannt werden!"
msg2 = "Das Stichwort 'undefiniert' kann nicht verwendet werden!"
msg3 = "Das Stichwort fr das ausgewhlte Profil wurde nicht gendert!"
msg4 = "Die Zeichen \,/,:,*,?," & chr(34) & ",<,>,| drfen nicht verwendet werden!"
msg5 = "Das Stichwort muss mindestens ein Zeichen enthalten!"

if Stichwort = "undefiniert" then
	msgbox msg1,vbInformation,"Hinweis"
	FF_SetControl "Profilbearbeitung",Bezeichner,Stichwort
	exit sub
elseif FF_GetControl("Profilbearbeitung",Bezeichner) = "undefiniert" then
	msgbox msg2,vbInformation,"Hinweis"
	FF_SetControl "Profilbearbeitung",Bezeichner,Stichwort
	exit sub
elseif Stichwort = FF_GetControl("Profilbearbeitung",Bezeichner) then
	msgbox msg3,vbInformation,"Hinweis"
	exit sub
else
	NameNeu = trim(FF_GetControl("Profilbearbeitung",Bezeichner))
	if not Zeichentest_Ok (NameNeu) then
		msgbox msg4,vbInformation,"Hinweis"
		FF_SetControl "Profilbearbeitung",Bezeichner,Stichwort
		exit sub
	end if
	if len(nameNeu) = 0 then
		msgbox msg5,vbInformation,"Hinweis"
		FF_SetControl "Profilbearbeitung",Bezeichner,Stichwort
		exit sub
	end if
	
	'neuen Namen in Profile eintragen
	Bezeichner = ""
	for n = 0 to flagProfil : Bezeichner = Bezeichner & "|" : next
	FF_SetControl Dialog,Bezeichner,NameNeu
	NameNeu = chr(65 + flagProfil) & "_" & NameNeu
end if

'Profildatei umbenennen
objFS.MoveFile ProfilOrdner & "\" & ProfilEintrag(2,flagProfil),ProfilOrdner & "\" & NameNeu & ".wfp"
Stichwort = mid(NameNeu,3)

'Eintrge
ProfilEintrag(0,flagProfil) = NameNeu			'neues Stichwort
ProfilEintrag(2,flagProfil) = NameNeu & ".wfp"	'Profilname

End Sub
'------------------------------------------------------------------------
Sub ProfilErstellen
Dim NameNeu,Stichwort,Bezeichner,ProfDatei,ProfNeu,Datei

'Msgbox ProfilEintrag(0,flagProfil) & vbNewLine & ProfilEintrag(1,flagProfil) & vbNewLine & ProfilEintrag(2,flagProfil)

Stichwort = ProfilEintrag(0,flagProfil)
Bezeichner = "txt" & chr(65 + flagProfil)
ProfDatei = ProfilEintrag(2,flagProfil)

NameNeu = trim(FF_GetControl("Profilbearbeitung","txt" & chr(65 + flagProfil)))
if not Zeichentest_Ok (NameNeu) then
	msgbox "Die Zeichen \,/,:,*,?," & chr(34) & ",<,>,| drfen nicht verwendet werden!",vbInformation,"Hinweis"
	FF_SetControl "Profilbearbeitung",Bezeichner,Stichwort
	exit sub
end if

if NameNeu = "undefiniert" or len(NameNeu) = 0 then
	msgbox "Fr das zu erstellende Profil muss ein Stichwort eingegeben werden!",vbInformation,"Hinweis"
	FF_SetControl "Profilbearbeitung",Bezeichner,Stichwort
	exit sub
end if

if len(ProfilEintrag(2,flagProfil)) > 0 then
	Antwort = msgbox("Soll das vorhandene Profil " & ProfDatei & vbNewLine &_
					 "berschrieben werden?",vbQuestion + vbYesNo,"Sicherheitsabfrage")
	if Antwort = vbYes then
		ProfDatei = ProfilOrdner & "\" & ProfDatei
		if objFS.FileExists(ProfDatei) then objFS.DeleteFile ProfDatei,true
	else
		FF_SetControl "Profilbearbeitung",Bezeichner,Stichwort
		exit sub
	end if
end if

call RegDatei_Erstellen (RegPfad & RegSchluessel)
if not Abbruch then
	'Eintrge
	ProfilEintrag(0,flagProfil) = FF_GetControl("Profilbearbeitung",Bezeichner)				'neues Stichwort
	ProfilEintrag(1,flagProfil) = ProfilOrdner & "\img_" &  chr(65 + flagProfil) & ".png"	'neues Symbol
	ProfilEintrag(2,flagProfil) = chr(65 + flagProfil) & "_" & NameNeu & ".wfp"
	Bezeichner = ""
	for n = 0 to flagProfil : Bezeichner = Bezeichner & "|" : next
	FF_SetControl Dialog,Bezeichner,ProfilEintrag(0,flagProfil)
	FF_SetControl Dialog,"img_" & chr(65 + flagProfil),ProfilEintrag(1,flagProfil)
	FF_EnableControl Dialog,"img_" & chr(65 + flagProfil),true
	FF_EnableControl Dialog,"Profil&" & chr(97 + flagProfil),true
	FF_SetControl "Profilbearbeitung","img_" & chr(65 + flagProfil),ProfilEintrag(1,flagProfil)
	
	'RegDaten speichern
	ProfNeu = ProfilOrdner & "\" & chr(65 + flagProfil) & "_" & NameNeu & ".wfp"
	Set Datei = objFS.OpenTextFile(ProfNeu, ForWriting, True)
	Datei.Write RegDaten
	Datei.Close
else
	msgbox "Es konnte kein neues Profil erstellt werden!",vbExclamation,"Warnung"
	
	'Eintrge
	ProfilEintrag(0,flagProfil) = "undefiniert"														'neutrales Stichwort
	ProfilEintrag(1,flagProfil) = ProfilOrdner & "\img_neutral_" & chr(65 + flagProfil) & ".png"	'neutrales Symbol
	ProfilEintrag(2,flagProfil) = ""																'kein Profilname
	Bezeichner = ""
	for n = 0 to flagProfil : Bezeichner = Bezeichner & "|" : next
	FF_SetControl Dialog,Bezeichner,ProfilEintrag(0,flagProfil)
	FF_SetControl Dialog,"img_" & chr(65 + flagProfil),ProfilEintrag(1,flagProfil)
	FF_SetControl "Profilbearbeitung","txt" & chr(65 + flagProfil),ProfilEintrag(0,flagProfil)
	FF_SetControl "Profilbearbeitung","img_" & chr(65 + flagProfil),ProfilEintrag(1,flagProfil)
end if

End Sub
'------------------------------------------------------------------------
Sub RegDatei_Erstellen (Schluessel)
'Registrydaten ermitteln mit WMI-Verwaltungsdienst
Dim pos,HKEY,HKEY_Wert,Pfad

Abbruch = false

'## Vorbereitung
pos = instr(Schluessel,"\")
if pos > 0 then
	HKEY = left(Schluessel,pos -1)
else
	msgbox "Der HKEY-Schlssel ist falsch!",vbExclamation,"Abbruch"
	Abbruch = true : exit sub
end if

select case HKEY
	case "HKEY_CLASSES_Root"
		HKEY_Wert = &H80000000
	case "HKEY_CURRENT_USER"
		HKEY_Wert = &H80000001
	case "HKEY_LOCAL_MACHINE"
		HKEY_Wert = &H80000002
	case "HKEY_USERS"
		HKEY_Wert = &H80000003
	case "HKEY_CURRENT_CONFIG"
		HKEY_Wert = &H80000005
	case "HKEY_DYN_DATA"
		HKEY_Wert = &H80000006
case else
	msgbox "Der HKEY-Schlssel ist falsch!",vbExclamation,"Abbruch"
	Abbruch = true : exit sub
end select

Pfad = mid(Schluessel,pos +1)

'## Schlssel auslesen

Dim oReg
Set oReg = GetObject("winmgmts:{impersonationLevel=impersonate}!\\" & "." & "\root\default:StdRegProv")

Dim arrValueNames,arrValueTypes,element,Value

on error resume next
oReg.EnumValues HKEY_Wert,Pfad,arrValueNames,arrValueTypes

element = arrValueNames(0)
if err > 0 then
	msgbox "Der Schlssel" & vbNewLine & space(3) & HKEY & "\"  & vbNewLine & space(3) & Pfad & vbNewLine & _
				"ist ungltig bzw. nicht vorhanden!",vbExclamation,"Abbruch"
	Abbruch = true : exit sub
end if
on error goto 0

RegDaten = ""
for each element in arrValueNames
	oReg.GetStringValue HKEY_Wert,Pfad,element,Value
	if len(RegDaten) = 0 then
		RegDaten = element & " = " & Value
	else
		RegDaten = RegDaten & vbNewLine & element & " = " & Value
	end if
next

End Sub
'------------------------------------------------------------------------
'************************************************************************
'Delete-Funktion
'************************************************************************
'------------------------------------------------------------------------
Sub KillSkript
'Skript mit allen Komponenten entfernen

Dim SPfad

'### FixFotoScript.ini bereinigen
TempFile = FF_GetFFPathEx(1) & "\FixFotoScript.ini"
if objFS.FileExists(TempFile) then
	call IniBereinigung
	if Abbruch then exit sub
else
	msgbox 	"Die Datei FixFotoScript.ini konnte nicht gefunden werden." & vbNewLine & _
			"Der Lschvorgang wird abgebrochen!",vbExclamation,"Hinweis"
	exit sub
end if

'### zip-Archiv auf Wunsch sichern, dann lschen
TempFile = FF_GetScriptPath & "\" & objFS.GetBaseName(Skriptname) & ".zip"
if objFS.FileExists(TempFile) then
	Antwort = msgbox("Soll das Archiv " & objFS.GetBaseName(Skriptname) & ".zip" & _
			 " gesichert werden?",vbYesNo + vbQuestion,"Sicherheitskopie")
	if Antwort = vbYes then
		SPfad = FF_EnterPath(true,"Wo soll die Sicherheitskopie angelegt werden?")
		if SPfad = "" then
			msgbox "Das Lschen des Skripts wird abgebrochen!",vbExclamation,"Hinweis"
			exit sub
		end if
		SPfad = SPfad & "\" & objFS.GetBaseName(Skriptname) & ".zip"
		objFS.CopyFile Tempfile, SPfad, true
	end if
	objFS.DeleteFile TempFile,true
end if

'### Skriptdatei lschen
TempFile = FF_GetScriptPath & "\" & Skriptname
objFS.DeleteFile TempFile,true

'### beigepackten Ordner lschen
if objFS.FolderExists(ProfilOrdner) then objFS.DeleteFolder ProfilOrdner,true

'### ggf. Registry-Daten lschen
'TempFile = "HKEY_CURRENT_USER\Software\Joachim Koopmann Software\FixFoto\Script\" & RegSchluessel & "\"
'WshShell.RegDelete(TempFile)

'### Fertigmeldung
msgbox "Das Skript" & Skriptname & vbNewLine & "wurde mit allen Komponenten gelscht!" & vbNewLine & _
	   "Es wird empfohlen die 'Automatische Skriptkonfiguration' aufzurufen.",vbExclamation,"Hinweis"

End Sub
'------------------------------------------------------------------------
Sub IniBereinigung
'FixFotoScript.ini - Bereinigung

Dim Zeile, zNr,Anfang, Ende, DateiTmp, ZielZeile, tmpString
DateiTmp =  FF_GetFFPathEx(1) & "\FixFotoScript.tmp"

'### Wo befindet sich der Eintrag zum Skript?
Set Zeile = objFS.OpenTextFile(TempFile, ForReading)

zNr = 0
do Until Zeile.AtEndOfStream
	tmpString = Zeile.ReadLine
	zNr = zNr + 1
	if tmpString = "[Script]" then Anfang = zNr
	if tmpString = "File=.\" & Skriptname then
		Ende = zNr
		exit do	
	end if
loop 
Zeile.Close

if Ende <= Anfang then
	msgbox 	"Die Datei FixFotoScript.ini konnte nicht bereinigt werden." & vbNewLine & _
		"Der Lschvorgang wird abgebrochen!",vbExclamation,"Hinweis"
	Abbruch = true
	exit sub
end if

'### Zeilen ohne skriptbezogene Zeilen in DateiTmp bertragen
Set Zeile = objFS.OpenTextFile(TempFile, ForReading)
Set ZielZeile  = objFS.CreateTextFile(DateiTmp, True)

zNr = 0
do Until Zeile.AtEndOfStream
	tmpString = Zeile.ReadLine
	zNr = zNr + 1
	if zNr < Anfang or zNr > Ende then
		ZielZeile.WriteLine tmpString
	end if
loop 

Zeile.Close
ZielZeile.Close

'### Umkopieren von DateiTmp nach FixFotoScript.ini (TempFile)
objFS.CopyFile DateiTmp, TempFile, True
objFS.DeleteFile (DateiTmp)

End Sub
'------------------------------------------------------------------------
'************************************************************************
'Kurzbeschreibung
'************************************************************************
'------------------------------------------------------------------------
Sub KurzbeschreibungAnzeigen

Dim Taste
Dim TBreite	: TBreite = LaengeMax * 2.6 + 10
const THoehe = 180

const ES_READONLY = 2048
const WS_VSCROLL = 2097152

FF_AddDialog "Kurzbeschreibung",TBreite,THoehe
FF_AddControl "Kurzbeschreibung","Beschreibung","EDIT",0,0,TBreite,THoehe-20
FF_SetControlStyle "Kurzbeschreibung","Beschreibung", ES_READONLY + WS_VSCROLL
FF_AddControl "Kurzbeschreibung","OK","BUTTON",TBreite/2-15,THoehe-15,30,10

FF_SetControl "Kurzbeschreibung","Beschreibung",Kurzbeschreibung

do
	Taste = FF_ShowDialog("Kurzbeschreibung")
	if Taste = "CANCEL" or Taste = "OK" then exit do
loop
call FF_CloseDialog("Kurzbeschreibung")

End Sub
'------------------------------------------------------------------------
Sub KurzbeschreibungLesen
on error resume next
Const ForReading = 1
Dim Skript, Anfang, Ende, Zeile

Set Skript = objFS.OpenTextFile(FF_GetScriptPath & "\" & SkriptName, ForReading, False)

if err.number = 53 then
	msgbox "Wahrscheinlich wurde der Originalskriptname " & """" & SkriptName & """" & " abgendert." & vbNewLine & _
		   "Die Kurzbeschreibung kann daher nicht angezeigt werden.",vbExclamation,"Meldung"
	Abbruch = True
	exit sub
end if

Do While Skript.AtEndOfStream <> True
	Zeile = Skript.ReadLine
	
	if instr(Zeile,"** Ende Kurzbeschreibung") > 0 then Ende = true
	if Ende then exit do
	
	if Anfang then Kurzbeschreibung = Kurzbeschreibung & mid(Zeile,2) & vbNewLine
	if len(Zeile)-1 > LaengeMax then LaengeMax = len(Zeile)-1
	
	if instr(Zeile,"** Start Kurzbeschreibung") > 0 then Anfang = true
	
Loop
	
if Anfang and Ende then KBvorhanden = true
Skript.Close

End Sub
'------------------------------------------------------------------------
'************************************************************************
'Allgemein
'************************************************************************
'------------------------------------------------------------------------
Function Version_OK(MinVersion)
'Test der FF-Version
Dim VersNr

 VersNr=split(MinVersion,".")
 Version_OK=FF_GetMajor * 1000 + FF_GetMinor + FF_GetBuild / 1000 >=_
     		VersNr(0) * 1000 + VersNr(1) + VersNr(2) / 1000

End Function
'------------------------------------------------------------------------
Function Zeichentest_Ok (DName)
'Test auf unzulssige Zeichen bei Dateinamen
Dim zArray,z

zArray = split("\,/,:,*,?,<,>,|" & chr(34),",")
for each z in zArray
	if instr(DName,z) > 0 then
		Zeichentest_Ok = false
		exit function
	end if
next
Zeichentest_Ok = true

End Function
'------------------------------------------------------------------------
